#
# spec file for package yast2-python-bindings
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%if 0%{?suse_version} > 1310 || 0%{?fedora_version} > 20
%define with_python3 1
%else
%define with_python3 0
%endif

%define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; import sys; sys.stdout.write(get_python_lib())")
%define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; import sys; sys.stdout.write(get_python_lib(1))")
%define python3_sitelib %(%{__python3} -c "from distutils.sysconfig import get_python_lib; import sys; sys.stdout.write(get_python_lib())")
%define python3_sitearch %(%{__python3} -c "from distutils.sysconfig import get_python_lib; import sys; sys.stdout.write(get_python_lib(1))")

Name:           yast2-python-bindings
Version:        4.0.3
Release:        lp150.1.1
Summary:        Python bindings for the YaST platform
License:        GPL-2.0
Group:          System/YaST

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source0:        %{name}-%{version}.tar.bz2

BuildRequires:  autoconf
BuildRequires:  autoconf-archive
BuildRequires:  automake
BuildRequires:  gcc-c++
BuildRequires:  libtool
BuildRequires:  libyui-devel
BuildRequires:  make
BuildRequires:  python
BuildRequires:  python-devel
%if %{with_python3}
BuildRequires:  python3
BuildRequires:  python3-devel
%endif
BuildRequires:  swig
BuildRequires:  yast2-core-devel
BuildRequires:  yast2-ycp-ui-bindings
BuildRequires:  yast2-ycp-ui-bindings-devel
Requires:       python
Requires:       yast2-core
Requires:       yast2-ycp-ui-bindings
Obsoletes:      yast2-python-bindings < 4.0.1
Conflicts:      yast2-python3-bindings

%description -n yast2-python-bindings
The bindings allow YaST modules to be written using the Python language
and also Python scripts can use YaST agents, APIs and modules.

%if %{with_python3}
%package -n yast2-python3-bindings
Summary:        Python3 bindings for the YaST platform
Group:          System/YaST
Requires:       python3
Requires:       yast2-core
Requires:       yast2-ycp-ui-bindings
Obsoletes:      yast2-python-bindings == 4.0.1
Conflicts:      yast2-python-bindings

%description -n yast2-python3-bindings
The bindings allow YaST modules to be written using the Python language
and also Python scripts can use YaST agents, APIs and modules.
%endif

%define builddir %{_builddir}/%{name}-%{version}

%prep
%setup -n %{name}-%{version}

%build
make -f Makefile.cvs all

%if %{with_python3}
%configure --enable-python3
make
mkdir -p %{builddir}/python3
%__cp -d src/*.py %{builddir}/python3
%__cp -d src/.libs/*.so.0.0.0 %{builddir}/python3
%__cp -d src/*.la %{builddir}/python3
make clean
%endif

%configure
make

%install
%yast_install
rm %{buildroot}/%{python_sitelib}/*.pyc
rm %{buildroot}/%{python_sitelib}/*.pyo
rm %{buildroot}/%{python_sitearch}/*.la
rm %{buildroot}/%{yast_plugindir}/*.la
%if %{with_python3}
%__mkdir_p %{buildroot}/%{python3_sitelib}/
%__install -m 0644 %{builddir}/python3/*.py %{buildroot}/%{python3_sitelib}/
%__mkdir_p %{buildroot}/%{python3_sitearch}/
%__install -m 0755 %{builddir}/python3/_ycp.so* %{buildroot}/%{python3_sitearch}/
%__ln_s %{python3_sitearch}/_ycp.so.0.0.0 %{buildroot}/%{python3_sitearch}/_ycp.so.0
%__ln_s %{python3_sitearch}/_ycp.so.0.0.0 %{buildroot}/%{python3_sitearch}/_ycp.so
%__install -m 0755 %{builddir}/python3/libpy2lang_python.so.0.0.0 %{buildroot}/%{yast_plugindir}/libpy2lang_python3.so.0.0.0
%__ln_s %{yast_plugindir}/libpy2lang_python3.so.0.0.0 %{buildroot}/%{yast_plugindir}/libpy2lang_python3.so
%__ln_s %{yast_plugindir}/libpy2lang_python3.so.0.0.0 %{buildroot}/%{yast_plugindir}/libpy2lang_python3.so.0
%endif

%if %{with_python3}
%files -n yast2-python3-bindings
%defattr (-, root, root)
%doc %{yast_docdir}
%{python3_sitelib}/*.py
%{python3_sitearch}/_ycp.so*
%{yast_plugindir}/libpy2lang_python3.so.*
%{yast_plugindir}/libpy2lang_python3.so
%endif

%files -n yast2-python-bindings
%defattr (-, root, root)
%doc %{yast_docdir}
%{python_sitelib}/*.py
%{python_sitearch}/_ycp.so*
%{yast_plugindir}/libpy2lang_python.so.*
%{yast_plugindir}/libpy2lang_python.so

%changelog
* Fri Mar  9 2018 dmulder@suse.com
- Adapt the bindings to allow modules that will run in both python2
  or python3. Also fix a py3 binary mistakenly packaged with the py2
  bindings package (bsc#1074696).
* Mon Jan 29 2018 dmulder@suse.com
- Build both python2 and python3 versions of the bindings;
  (bsc#1074696).
* Thu Jan  4 2018 dmulder@suse.com
- Convert the bindings into python3; (bsc#1074696).
- Fix some code examples; (bsc#1070212).
* Tue Nov 28 2017 dmulder@suse.com
- Add example code ported from ruby examples; (bsc#1070212).
- Fixes based on findings from example code
* Wed Nov  8 2017 dmulder@suse.com
- Rewrite the python bindings using swig fate#324146
* Wed Nov 13 2013 jreidinger@suse.com
- Add explicit COPYING file
* Thu Sep 19 2013 lslezak@suse.cz
- do not use *.spec.in template, use *.spec file with RPM macros
  instead
- 3.1.0
* Tue Jul 30 2013 yast-devel@opensuse.org
- version 3.0.0
* Tue Jun 11 2013 jmatejek@suse.com
- install to correct python directory (fixes file conflict with
  python-base)
- 2.20.2
* Fri Jun 29 2012 aschnell@suse.de
- blocxx is no longer needed for build
* Tue Jun 26 2012 aschnell@suse.de
- adapted to namespace changes in yast2-core
- 2.20.1
* Fri Nov 25 2011 coolo@suse.com
- add libtool as buildrequire to avoid implicit dependency
* Mon Sep  6 2010 juhliarik@suse.cz
- added patch for building with python 2.7
- 2.20.0
* Thu Feb  4 2010 juhliarik@suse.cz
- added patch from (bnc#520499) it solves problem with importing
  names
- 2.19.0
* Mon Dec 15 2008 juhliarik@suse.cz
- added fix for problem with strict-aliasing (bnc #444472)
  - 2.17.4
* Wed Sep 24 2008 visnov@suse.cz
- y2debug is always logged (bnc#426554)
- 2.17.3
* Tue Sep  9 2008 visnov@suse.cz
- build with python 2.6
- 2.17.2
* Fri Jun 27 2008 juhliarik@suse.cz
- added support for GET/SET variables in YCP module (bnc #402684)
- 2.17.1
* Mon Feb 25 2008 juhliarik@suse.cz
- Added support for creating known widget names in ycp module
- V 2.16.6
* Thu Feb 21 2008 sh@suse.de
- Added new UI packages to Requires/BuildRequires in .spec file
- V 2.16.5
* Wed Feb 20 2008 sh@suse.de
- New include path for YUIComponent.h
- V 2.16.4
* Mon Jan 21 2008 juhliarik@suse.cz
- Added pacth for bug#355064 - problem with SCR.Write
- V 2.16.3
* Wed Dec  5 2007 juhliarik@suse.cz
- Added patch for problem with handling error from python
- Correction for handling adding None(nil) as argument to yast function
- V 2.16.2
* Thu Nov 15 2007 juhliarik@suse.cz
- Addded correction in makefile and for YCPDeclaration
- V 2.16.1
* Wed Nov 14 2007 juhliarik@suse.cz
- Adding solution for calling python function via reference
- Adding support for calling YCode in Sequencer from python
- Reimplementation SCR
- V 2.16.0
* Sun Sep  9 2007 juhliarik@suse.cz
- Adding support for calling SCR
- Adding support for ycp types symbol, term, path
- Adding support for calling UI from YaST
- Added patch for bug #308213 and bug# 300909
- V 2.15.3
* Fri Aug 10 2007 mvidner@suse.cz
- Finished integrating Feature #120292, UI as a namespace callable
  from yast2-*-bindings.
- 2.15.2
* Mon Aug  6 2007 juhliarik@suse.cz
- initial version
  V 2.15.1
